=== files/CMakeLists.txt ===
add_subdirectory(mygui)
add_subdirectory(shaders)
