=== debian/changelog ===
openmw (0.38.0-1build1) xenial; urgency=medium

  * No-change rebuild for liblinearmath transition.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 09 Feb 2016 10:36:40 +0000

openmw (0.38.0-1) unstable; urgency=low

  [ Bret Curtis ]
  * Upstream release: OpenMW-0.38.0
  * Updated libpng12-dev to libpng-dev to ease transition (Closes: #810201)

  [ Scott Howard ]
  * Updated debian/copyright

 -- Bret Curtis <psi29a@gmail.com>  Wed, 20 Jan 2016 08:14:09 +0200

openmw (0.37.0-1) unstable; urgency=medium

  [Scott Howard]
  * Added BDs on libopenscenegraph-dev libqt4-opengl-dev 
    for daily builds and to prep for OSG release
  * updated openmw-data.install to install all resources
  * added openmw depend on libtxc-dxtn-s2tc
  * Instal openmw.appdata.xml

  [Bret Curtis]
  * Switch from libav to ffmpeg
  * Upstream release: OpenMW-0.37.0 (Closes: #803848, #799722)

 -- Bret Curtis <psi29a@gmail.com>  Thu, 26 Nov 2015 08:00:37 -0400
